<template>
  <NodeViewWrapper>
    <v-fade-transition origin="top center">
      <div class="flex flex-col relative">
        <div draggable="true" data-drag-handle data :class="wrapperClassName" :style="{ width: imageWrapperWidth }">
          <div contenteditable="false" ref="imageWrapperRef" class="rounded-[4px] overflow-hidden my-2 cover">
            <img class="block py-0 w-full" :src="src" alt="" @click="onClick" />
          </div>
        </div>
  
        <div v-show="dialog" class="w-fit flex absolute top-0 left-1/2 -translate-x-1/2 items-center self-center rounded-[8px] gap-2 px-3 py-2 bg-surface cardShadow">
          <div
            class="flex p-1 hover:bg-very-light-grey rounded cursor-pointer items-center justify-center !text-dark-grey hover:!text-fake-black"
            :class="editor?.isActive('imageBlock', { align: 'left' }) ? 'bg-very-light-grey !text-fake-black' : ''"
            @click="editor.chain().focus(undefined, { scrollIntoView: false }).setImageBlockAlign('left').run()"
          >
            <Icon icon="fluent:align-left-24-regular" height="20" width="20" />
          </div>
    
          <div
            class="flex p-1 hover:bg-very-light-grey rounded cursor-pointer items-center justify-center !text-dark-grey hover:!text-fake-black"
            :class="editor?.isActive('imageBlock', { align: 'center' }) ? 'bg-very-light-grey !text-fake-black' : ''"
            @click="editor.chain().focus(undefined, { scrollIntoView: false }).setImageBlockAlign('center').run()"
          >
            <Icon icon="gravity-ui:object-align-center-horizontal" height="20" width="20" />
          </div>
    
          <div
            class="flex p-1 hover:bg-very-light-grey rounded cursor-pointer items-center justify-center !text-dark-grey hover:!text-fake-black"
            :class="editor?.isActive('imageBlock', { align: 'right' }) ? 'bg-very-light-grey !text-fake-black' : ''"
            @click="editor.chain().focus(undefined, { scrollIntoView: false }).setImageBlockAlign('right').run()"
          >
            <Icon icon="fluent:align-right-24-regular" height="20" width="20" />
          </div>
    
          <div class="mx-1" />
    
          <ImageBlockWidth :width="imageWrapperWidth" @handle-change="editor.chain().focus(undefined, { scrollIntoView: false }).setImageBlockWidth($event).run()" />
        </div>
      </div>
    </v-fade-transition>
  </NodeViewWrapper>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import { ref, computed, watch } from 'vue';
import { nodeViewProps, NodeViewWrapper } from '@tiptap/vue-3';
import ImageBlockWidth from '../component/ImageBlockWidth.vue';

const props = defineProps(nodeViewProps);

const { src } = props.node.attrs;

const dialog = ref(false);
const imageWrapperRef = ref(props.node.attrs.align);
const imageWrapperWidth = ref(props.node.attrs.width || 100);
const imageWrapperAlign = ref('center');

const wrapperClassName = computed(() => {
  const align = imageWrapperAlign.value;
  
  switch (align) {
    case 'left':
      return 'ml-0 mr-auto'
    case 'center':
      return 'mx-auto'
    case 'right':
      return 'ml-auto mr-0'
    default:
      return 'mx-auto'
  }
})

const onClick = () => {
  props.editor.commands.setNodeSelection(props.getPos());
  dialog.value = !dialog.value
};

watch(props, (newValue, oldValue) => {
  if (newValue.node) {
    imageWrapperWidth.value = props.node.attrs.width
    imageWrapperAlign.value = props.node.attrs.align
  }
})
</script>

<style lang="scss">
.cardShadow {
  box-shadow: 0px 8px 10px 0px rgba(0, 0, 0, 0.14), 0px 3px 14px 0px rgba(0, 0, 0, 0.12), 0px 5px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>